Index: /trunk/admin/include/functions_upgrade.php
===================================================================
--- /trunk/admin/include/functions_upgrade.php	(revision 2835)
+++ /trunk/admin/include/functions_upgrade.php	(revision 2836)
@@ -24,15 +24,9 @@
 function check_upgrade()
 {
-  // Is Piwigo already installed ?
-  if (!defined('PHPWG_IN_UPGRADE') or !PHPWG_IN_UPGRADE)
+  if (defined('PHPWG_IN_UPGRADE'))
   {
-    $message = 'Piwigo is not in upgrade mode. In include/mysql.inc.php,
-insert line
-<pre style="background-color:lightgray">
-define(\'PHPWG_IN_UPGRADE\', true);
-</pre>
-if you want to upgrade';
-    die($message);
+    return PHPWG_IN_UPGRADE;
   }
+  return false;
 }
 
@@ -138,3 +132,46 @@
 }
 
+// Check access rights
+function check_upgrade_access_rights($current_release, $username, $password)
+{
+  global $conf, $page;
+
+  if (version_compare($current_release, '1.5.0', '<'))
+  {
+    $query = '
+SELECT password, status
+FROM '.PREFIX_TABLE.'users
+WHERE username = "'.$username.'"
+;';
+  }
+  else
+  {
+    $query = '
+SELECT u.password, ui.status
+FROM '.$conf['users_table'].' AS u
+INNER JOIN '.PREFIX_TABLE.'user_infos AS ui
+ON u.id = ui.user_id
+WHERE '.$conf['user_fields']['username'].'="'.$username.'"
+;';
+  }
+  $row = mysql_fetch_assoc(mysql_query($query));
+
+  if (!isset($conf['pass_convert']))
+  {
+    $conf['pass_convert'] = create_function('$s', 'return md5($s);');
+  }
+
+  if ($row['password'] != $conf['pass_convert']($_POST['password']))
+  {
+    array_push($page['errors'], l10n('invalid_pwd'));
+  }
+  elseif ($row['status'] != 'admin' and $row['status'] != 'webmaster')
+  {
+    array_push($page['errors'], l10n('You do not have access rights to run upgrade'));
+  }
+  else
+  {
+    define('PHPWG_IN_UPGRADE', true);
+  }
+}
 ?>
Index: /trunk/install/db/65-database.php
===================================================================
--- /trunk/install/db/65-database.php	(revision 2835)
+++ /trunk/install/db/65-database.php	(revision 2836)
@@ -130,6 +130,6 @@
   while ( $row=mysql_fetch_assoc($result) )
   {
-    $lang = $row["language"];
-    $lang_def = explode('.', $lang);
+    $language = $row["language"];
+    $lang_def = explode('.', $language);
     if ( count($lang_def)==2 )
     {
@@ -142,10 +142,10 @@
       $charset = 'iso-8859-1';
     }
-    $all_langs[$lang] = array(
+    $all_langs[$language] = array(
       'count' => $row['count'],
       'new_lang' => $new_lang,
       'charset' => $charset,
       );
-    $upgrade_log .= ">>user_lang\t".$lang."\t".$row['count']."\n";
+    $upgrade_log .= ">>user_lang\t".$language."\t".$row['count']."\n";
   }
   $upgrade_log .= "\n";
Index: /trunk/install/upgrade_1.3.1.php
===================================================================
--- /trunk/install/upgrade_1.3.1.php	(revision 2835)
+++ /trunk/install/upgrade_1.3.1.php	(revision 2836)
@@ -592,5 +592,5 @@
 <pre style="background-color:lightgray">?&gt;</pre>
 insert
-<pre style="background-color:lightgray">define(\'PHPWG_INSTALLED\', true);<pre>'
+<pre style="background-color:lightgray">define(\'PHPWG_INSTALLED\', true);</pre>'
     )
   );
Index: /trunk/install/upgrade_1.7.0.php
===================================================================
--- /trunk/install/upgrade_1.7.0.php	(revision 2835)
+++ /trunk/install/upgrade_1.7.0.php	(revision 2836)
@@ -117,5 +117,5 @@
 
 echo '</pre>';
-ob_clean();
+ob_end_clean();
 
 // now we upgrade from 2.0.0
Index: /trunk/language/de_DE/upgrade.lang.php
===================================================================
--- /trunk/language/de_DE/upgrade.lang.php	(revision 2835)
+++ /trunk/language/de_DE/upgrade.lang.php	(revision 2836)
@@ -33,7 +33,8 @@
 $lang['Upgrade informations'] = 'Upgrade informations';
 $lang['delete upgrade files'] = '[Security] Delete files "upgrade.php", "upgrade_feed.php", "install.php" and "install" directory';
-$lang['remove line from mysql.inc.php'] = 'In include/mysql.inc.php, remove:';
-$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>General>Maintenance] if you encounter any problem.';
+$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>Specials>Maintenance] if you encounter any problem.';
 $lang['deactivated plugins'] = 'As a precaution, following plugins have been deactivated. You must check for plugins upgrade before reactiving them:';
+$lang['upgrade login message'] = 'Only administrator can run upgrade: please sign in below.';
+$lang['You do not have access rights to run upgrade'] = 'You do not have access rights to run upgrade';
 
 ?>
Index: /trunk/language/en_UK/upgrade.lang.php
===================================================================
--- /trunk/language/en_UK/upgrade.lang.php	(revision 2835)
+++ /trunk/language/en_UK/upgrade.lang.php	(revision 2836)
@@ -32,7 +32,8 @@
 $lang['Upgrade informations'] = 'Upgrade informations';
 $lang['delete upgrade files'] = '[Security] Delete files "upgrade.php", "upgrade_feed.php", "install.php" and "install" directory';
-$lang['remove line from mysql.inc.php'] = 'In include/mysql.inc.php, remove:';
-$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>General>Maintenance] if you encounter any problem.';
+$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>Specials>Maintenance] if you encounter any problem.';
 $lang['deactivated plugins'] = 'As a precaution, following plugins have been deactivated. You must check for plugins upgrade before reactiving them:';
+$lang['upgrade login message'] = 'Only administrator can run upgrade: please sign in below.';
+$lang['You do not have access rights to run upgrade'] = 'You do not have access rights to run upgrade';
 
 ?>
Index: /trunk/language/es_ES/upgrade.lang.php
===================================================================
--- /trunk/language/es_ES/upgrade.lang.php	(revision 2835)
+++ /trunk/language/es_ES/upgrade.lang.php	(revision 2836)
@@ -32,7 +32,8 @@
 $lang['Upgrade informations'] = 'Informaciones sobre la puesta al día';
 $lang['delete upgrade files'] = '[Seguridad] Borre los ficheros "upgrade.php", "upgrade_feed.php", "install.php" así como el expediente "install"';
-$lang['remove line from mysql.inc.php'] = 'En el fichero include/mysql.inc.php, borre la línea siguiente:';
 $lang['perform a maintenance check'] = 'Por favor, efectúes un mantenimiento en [Administración>Especiales>Mantenimiento] si usted encuentra problemas.';
 $lang['deactivated plugins'] = 'Por precaución, el plugins siguiente han sido desactivados. Verifique si existen unas posturas al día antes de reactivarlas:';
+/*TODO*/$lang['upgrade login message'] = 'Only administrator can run upgrade: please sign in below.';
+/*TODO*/$lang['You do not have access rights to run upgrade'] = 'You do not have access rights to run upgrade';
 
 ?>
Index: /trunk/language/fr_FR/upgrade.lang.php
===================================================================
--- /trunk/language/fr_FR/upgrade.lang.php	(revision 2835)
+++ /trunk/language/fr_FR/upgrade.lang.php	(revision 2836)
@@ -24,5 +24,6 @@
 $lang['Upgrade'] = 'Mise à jour';
 $lang['introduction message'] = 'Cette page vous propose de mettre à jour la base de donnée correspondante à votre ancienne version de piwigo vers la nouvelle version.
-L\'assistant de mise à jour pense la version actuelle est une <strong>version %s</strong> (ou équivalente).';
+L\'assistant de mise à jour pense que la version actuelle est une <strong>version %s</strong> (ou équivalente).';
+$lang['upgrade login message'] = 'Seul un adminitrateur peut lancer la mise à jour: veuillez vous identifier ci-dessous.';
 $lang['Upgrade from %s to %s'] = 'Mise à jour de la version %s à %s';
 $lang['Statistics'] = 'Statistiques';
@@ -32,7 +33,8 @@
 $lang['Upgrade informations'] = 'Informations sur la mise à jour';
 $lang['delete upgrade files'] = '[Sécurité] Effacez les fichiers "upgrade.php", "upgrade_feed.php", "install.php" ainsi que le dossier "install"';
-$lang['remove line from mysql.inc.php'] = 'Dans le fichier include/mysql.inc.php, effacez la ligne suivante:';
 $lang['perform a maintenance check'] = 'Veuillez effectuer une maintenance dans [Administration>Spéciales>Maintenance] si vous rencontrez des problèmes.';
 $lang['deactivated plugins'] = 'Par précaution, les plugins suivants ont été désactivés. Vérifiez s\'il existe des mises à jour avant de les réactiver:';
+$lang['upgrade login message'] = 'Seul un adminitrateur peut lancer la mise à jour: veuillez vous identifier ci-dessous.';
+$lang['You do not have access rights to run upgrade'] = 'Vous n\'avez pas les droits necessaires pour lancer la mise à jour.';
 
 ?>
Index: /trunk/language/it_IT/upgrade.lang.php
===================================================================
--- /trunk/language/it_IT/upgrade.lang.php	(revision 2835)
+++ /trunk/language/it_IT/upgrade.lang.php	(revision 2836)
@@ -26,4 +26,5 @@
 $lang['introduction message'] = 'This page proposes to upgrade your database corresponding to your old version of Piwigo to the current version.
 The upgrade assistant thinks you are currently running a <strong>release %s</strong> (or equivalent).';
+$lang['upgrade login message'] = 'Only administrator can run upgrade: please sign in below.';
 $lang['Upgrade from %s to %s'] = 'Upgrade from version %s to %s';
 $lang['Statistics'] = 'Statistics';
@@ -33,7 +34,8 @@
 $lang['Upgrade informations'] = 'Upgrade informations';
 $lang['delete upgrade files'] = '[Security] Delete files "upgrade.php", "upgrade_feed.php", "install.php" and "install" directory';
-$lang['remove line from mysql.inc.php'] = 'In include/mysql.inc.php, remove:';
-$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>General>Maintenance] if you encounter any problem.';
+$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>Specials>Maintenance] if you encounter any problem.';
 $lang['deactivated plugins'] = 'As a precaution, following plugins have been deactivated. You must check for plugins upgrade before reactiving them:';
+$lang['upgrade login message'] = 'Only administrator can run upgrade: please sign in below.';
+$lang['You do not have access rights to run upgrade'] = 'You do not have access rights to run upgrade';
 
 ?>
Index: /trunk/language/nl_NL/upgrade.lang.php
===================================================================
--- /trunk/language/nl_NL/upgrade.lang.php	(revision 2835)
+++ /trunk/language/nl_NL/upgrade.lang.php	(revision 2836)
@@ -26,4 +26,5 @@
 $lang['introduction message'] = 'This page proposes to upgrade your database corresponding to your old version of Piwigo to the current version.
 The upgrade assistant thinks you are currently running a <strong>release %s</strong> (or equivalent).';
+$lang['upgrade login message'] = 'Only administrator can run upgrade: please sign in below.';
 $lang['Upgrade from %s to %s'] = 'Upgrade from version %s to %s';
 $lang['Statistics'] = 'Statistics';
@@ -33,7 +34,8 @@
 $lang['Upgrade informations'] = 'Upgrade informations';
 $lang['delete upgrade files'] = '[Security] Delete files "upgrade.php", "upgrade_feed.php", "install.php" and "install" directory';
-$lang['remove line from mysql.inc.php'] = 'In include/mysql.inc.php, remove:';
-$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>General>Maintenance] if you encounter any problem.';
+$lang['perform a maintenance check'] = 'Perform a maintenance check in [Administration>Specials>Maintenance] if you encounter any problem.';
 $lang['deactivated plugins'] = 'As a precaution, following plugins have been deactivated. You must check for plugins upgrade before reactiving them:';
+$lang['upgrade login message'] = 'Only administrator can run upgrade: please sign in below.';
+$lang['You do not have access rights to run upgrade'] = 'You do not have access rights to run upgrade';
 
 ?>
Index: /trunk/upgrade.php
===================================================================
--- /trunk/upgrade.php	(revision 2835)
+++ /trunk/upgrade.php	(revision 2836)
@@ -30,4 +30,9 @@
 define('PHPWG_ROOT_PATH', './');
 
+if (!file_exists(PHPWG_ROOT_PATH.'include/mysql.inc.php'))
+{
+  die('Could not find include/mysql.inc.php file.');
+}
+
 include_once(PHPWG_ROOT_PATH.'include/functions.inc.php');
 include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
@@ -37,6 +42,4 @@
 include(PHPWG_ROOT_PATH . 'include/config_default.inc.php');
 @include(PHPWG_ROOT_PATH. 'include/config_local.inc.php');
-
-check_upgrade();
 
 prepare_conf_upgrade();
@@ -54,16 +57,4 @@
 }
 
-// +-----------------------------------------------------------------------+
-// |                            tricky output                              |
-// +-----------------------------------------------------------------------+
-echo '<!-- This is an HTML comment given in order to make IE outputs';
-echo ' the code.'."\n";
-echo ' Indeed, IE doesn\'t start to send output until a limit';
-echo ' of XXX bytes '."\n";
-echo str_repeat( ' ', 80 )."\n";
-echo str_repeat( ' ', 80 )."\n";
-echo str_repeat( ' ', 80 )."\n";
-echo '-->'."\n";
-flush();
 // +-----------------------------------------------------------------------+
 // |                              functions                                |
@@ -169,7 +160,7 @@
 }
 
-load_language( 'common.lang', '', array('language'=>$language, 'target_charset'=>'utf-8') );
-load_language( 'admin.lang', '', array('language'=>$language, 'target_charset'=>'utf-8') );
-load_language( 'upgrade.lang', '', array('language'=>$language, 'target_charset'=>'utf-8') );
+load_language( 'common.lang', '', array('language'=>$language, 'target_charset'=>'utf-8', 'no_fallback' => true) );
+load_language( 'admin.lang', '', array('language'=>$language, 'target_charset'=>'utf-8', 'no_fallback' => true) );
+load_language( 'upgrade.lang', '', array('language'=>$language, 'target_charset'=>'utf-8', 'no_fallback' => true) );
 
 // +-----------------------------------------------------------------------+
@@ -181,14 +172,4 @@
 $template->assign('RELEASE', PHPWG_VERSION);
 
-foreach (get_languages('utf-8') as $language_code => $language_name)
-{
-  if ($language == $language_code)
-  {
-    $template->assign('language_selection', $language_code);
-  }
-  $languages_options[$language_code] = $language_name;
-}
-$template->assign('language_options', $languages_options);
-
 // +-----------------------------------------------------------------------+
 // |                            upgrade choice                             |
@@ -198,55 +179,43 @@
 $columns_of = get_columns_of($tables);
 
-if (!isset($_GET['version']))
-{
-  // find the current release
-  if (!in_array('param', $columns_of[PREFIX_TABLE.'config']))
-  {
-    // we're in branch 1.3, important upgrade, isn't it?
-    if (in_array(PREFIX_TABLE.'user_category', $tables))
-    {
-      $current_release = '1.3.1';
-    }
-    else
-    {
-      $current_release = '1.3.0';
-    }
-  }
-  else if (!in_array(PREFIX_TABLE.'user_cache', $tables))
-  {
-    $current_release = '1.4.0';
-  }
-  else if (!in_array(PREFIX_TABLE.'tags', $tables))
-  {
-    $current_release = '1.5.0';
-  }
-  else if ( !in_array(PREFIX_TABLE.'history_summary', $tables) )
-  {
-    if (!in_array('auto_login_key', $columns_of[PREFIX_TABLE.'user_infos']))
-    {
-      $current_release = '1.6.0';
-    }
-    else
-    {
-      $current_release = '1.6.2';
-    }
-  }
-  else if (!in_array('md5sum', $columns_of[PREFIX_TABLE.'images']))
-  {
-    $current_release = '1.7.0';
+// find the current release
+if (!in_array('param', $columns_of[PREFIX_TABLE.'config']))
+{
+  // we're in branch 1.3, important upgrade, isn't it?
+  if (in_array(PREFIX_TABLE.'user_category', $tables))
+  {
+    $current_release = '1.3.1';
   }
   else
   {
-    die('No upgrade required, the database structure is up to date');
-  }
-
-  $template->assign(
-    'introduction',
-    array(
-      'CURRENT_RELEASE' => $current_release,
-      'RUN_UPGRADE_URL' =>
-        PHPWG_ROOT_PATH.'upgrade.php?version='.$current_release.'&amp;language='.$language,
-      )
-    );
+    $current_release = '1.3.0';
+  }
+}
+else if (!in_array(PREFIX_TABLE.'user_cache', $tables))
+{
+  $current_release = '1.4.0';
+}
+else if (!in_array(PREFIX_TABLE.'tags', $tables))
+{
+  $current_release = '1.5.0';
+}
+else if ( !in_array(PREFIX_TABLE.'history_summary', $tables) )
+{
+  if (!in_array('auto_login_key', $columns_of[PREFIX_TABLE.'user_infos']))
+  {
+    $current_release = '1.6.0';
+  }
+  else
+  {
+    $current_release = '1.6.2';
+  }
+}
+else if (!in_array('md5sum', $columns_of[PREFIX_TABLE.'images']))
+{
+  $current_release = '1.7.0';
+}
+else
+{
+  die('No upgrade required, the database structure is up to date');
 }
 
@@ -254,16 +223,17 @@
 // |                            upgrade launch                             |
 // +-----------------------------------------------------------------------+
-
-else
-{
-  if (in_array('md5sum', $columns_of[PREFIX_TABLE.'images']))
-  {
-    die('No database upgrade required, do not refresh the page');
-  }
-
-  $upgrade_file = PHPWG_ROOT_PATH.'install/upgrade_'.$_GET['version'].'.php';
+$page['infos'] = array();
+$page['errors'] = array();
+
+if (isset($_POST['username']) and isset($_POST['password']))
+{
+  check_upgrade_access_rights($current_release, $_POST['username'], $_POST['password']);
+}
+
+if (isset($_POST['submit']) and check_upgrade())
+{
+  $upgrade_file = PHPWG_ROOT_PATH.'install/upgrade_'.$current_release.'.php';
   if (is_file($upgrade_file))
   {
-    $page['infos'] = array();
     $page['upgrade_start'] = get_moment();
     $conf['die_on_sql_error'] = false;
@@ -284,5 +254,5 @@
       'upgrade',
       array(
-        'VERSION' => $_GET['version'],
+        'VERSION' => $current_release,
         'TOTAL_TIME' => get_elapsed_time(
           $page['upgrade_start'],
@@ -301,9 +271,6 @@
     array_push($page['infos'],
       l10n('delete upgrade files'),
-      l10n('remove line from mysql.inc.php') . '<pre>define(\'PHPWG_IN_UPGRADE\', true);</pre>',
       l10n('perform a maintenance check')
       );
-
-    $template->assign('infos', $page['infos']);
 
     invalidate_user_cache();
@@ -318,8 +285,39 @@
     pwg_query($query);
   }
-  else
-  {
-    die('Hacking attempt');
-  }
+}
+
+// +-----------------------------------------------------------------------+
+// |                          start template output                        |
+// +-----------------------------------------------------------------------+
+else
+{
+  foreach (get_languages('utf-8') as $language_code => $language_name)
+  {
+    if ($language == $language_code)
+    {
+      $template->assign('language_selection', $language_code);
+    }
+    $languages_options[$language_code] = $language_name;
+  }
+  $template->assign('language_options', $languages_options);
+
+  $template->assign('introduction', array(
+    'CURRENT_RELEASE' => $current_release,
+    'F_ACTION' => 'upgrade.php?language=' . $language));
+
+  if (!check_upgrade())
+  {
+    $template->assign('login', true);
+  }
+}
+
+if (count($page['errors']) != 0)
+{
+  $template->assign('errors', $page['errors']);
+}
+
+if (count($page['infos']) != 0)
+{
+  $template->assign('infos', $page['infos']);
 }
 
